zoukankan      html  css  js  c++  java
  • 687A: NP-Hard Problem

    Codeforces Round #360 Editorial [+ Challenges!]


    A. NP-Hard Problem
    time limit per test
    2 seconds
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    Recently, Pari and Arya did some research about NP-Hard problems and they found the minimum vertex cover problem very interesting.

    Suppose the graph G is given. Subset A of its vertices is called a vertex cover of this graph, if for each edge uv there is at least one endpoint of it in this set, i.e. or (or both).

    Pari and Arya have won a great undirected graph as an award in a team contest. Now they have to split it in two parts, but both of them want their parts of the graph to be a vertex cover.

    They have agreed to give you their graph and you need to find two disjoint subsets of its vertices A and B, such that both A and B are vertex cover or claim it's impossible. Each vertex should be given to no more than one of the friends (or you can even keep it for yourself).
    Input

    The first line of the input contains two integers n and m (2 ≤ n ≤ 100 000, 1 ≤ m ≤ 100 000) — the number of vertices and the number of edges in the prize graph, respectively.

    Each of the next m lines contains a pair of integers ui and vi (1  ≤  ui,  vi  ≤  n), denoting an undirected edge between ui and vi. It's guaranteed the graph won't contain any self-loops or multiple edges.
    Output

    If it's impossible to split the graph between Pari and Arya as they expect, print "-1" (without quotes).

    If there are two disjoint sets of vertices, such that both sets are vertex cover, print their descriptions. Each description must contain two lines. The first line contains a single integer k denoting the number of vertices in that vertex cover, and the second line contains k integers — the indices of vertices. Note that because of m ≥ 1, vertex cover cannot be empty.
    Examples
    Input

    4 2
    1 2
    2 3

    Output

    1
    2
    2
    1 3

    Input

    3 3
    1 2
    2 3
    1 3

    Output

    -1

    Note

    In the first sample, you can give the vertex number 2 to Arya and vertices numbered 1 and 3 to Pari and keep vertex number 4 for yourself (or give it someone, if you wish).


    Hint

    Try to use all of the vertices. Then look at the two vertex covers together in the graph and see how it looks like.
    Solution

    Looking at the two vertex covers in the graph, you see there must be no edge uv that u and v are in the same vertex cover. So the two vertex covers form a bipartition of the graph, so the graph have to be bipartite. And being bipartite is also sufficient, you can use each part as a vertex cover. Bipartition can be found using your favorite graph traversing algorithm(BFS or DFS). Here is a tutorial for bipartition of undirected graphs.

    The complexity is O(n + m).


    C++ code

    //     . .. ... .... ..... be name khoda ..... .... ... .. .     \
    
    #include <bits/stdc++.h>
    using namespace std;
    
    inline int in() { int x; scanf("%d", &x); return x; }
    const int N = 120021;
    
    vector <int> vc[2];
    vector <int> g[N];
    int mark[N];
    
    bool dfs(int v, int color = 2)
    {
    	mark[v] = color;
    	vc[color - 1].push_back(v);
    	for(int u : g[v])
    	{
    		if(!mark[u] && dfs(u, 3 - color))
    				return 1;
    		if(mark[u] != 3 - color)
    			return 1;
    	}
    	return 0;
    }
    
    int main()
    {
    	int n, m;
    	cin >> n >> m;
    	for(int i = 0; i < m; i++)
    	{
    		int u = in() - 1;
    		int v = in() - 1;
    		g[u].push_back(v);
    		g[v].push_back(u);
    	}
    	for(int i = 0; i < n; i++)
    		if(!mark[i])
    		{
    		     if(g[i].empty())
    		          continue;
    		     if(dfs(i))
    			{
    				cout << -1 << endl;
    				return 0;
    			}
    		}
    	for(int i = 0; i < 2; i++)
    	{
    		cout << vc[i].size() << endl;
    		for(int v : vc[i])
    			cout << v + 1 << " ";
    		cout << endl;
    	}
    }



    原文链接:Codeforces Round #360 Editorial [+ Challenges!] - Codeforces


  • 相关阅读:
    学习PyQt5(二):PyQt5布局管理
    学习PyQt5(一):安装PyQt5以及在PyCharm上配置PyQt5
    Day037--Python--线程的其他方法,GIL, 线程事件,队列,线程池,协程
    Day036--Python--线程
    Day035--Python--管道, Manager, 进程池, 线程切换
    Day034--Python--锁, 信号量, 事件, 队列, 生产者消费者模型, joinableQueue
    Day033--Python--进程
    Day032--Python--操作系统, process进程
    Day30--Python--struct, socketserver
    Day29--Python--缓冲区, 粘包
  • 原文地址:https://www.cnblogs.com/tigerisland/p/7564674.html
Copyright © 2011-2022 走看看